<?php
if ($vars['test']=='true') 			$ms['url']	='https://idealtest.rabobank.nl/ideal/mpiPayInitRabo.do';
else 								$ms['url']	='https://ideal.rabobank.nl/ideal/mpiPayInitRabo.do';	
$validUntil							=date("Y-m-d\TH:i:s",(time()+3000)).':000Z';
$paymentType						='ideal';
$merchant_id						=$vars['merchant_id'];
$merchant_key						=$vars['merchant_key'];
$merchant_subid						=$vars['merchant_subid'];
$amount								=(preg_replace("/^0/",'',$order['total_amount'])*100);
// creating the hash step by step in an array so we can easily debug it if there is something wrong
$hash_array=array();
$hash_array[] = $merchant_key;
$hash_array[] = $merchant_id;
$hash_array[] = $merchant_subid;
$hash_array[] = $amount;
$hash_array[] = $order['orders_id'];
$hash_array[] = $paymentType;
$hash_array[] = $validUntil;
foreach ($order['products'] as $product)
{
	// add possible TAX
	$item_price=(round($product['final_price']+($product['final_price']/100*$product['products_tax']),2)*100);
	$hash_array[] =$product['products_id'].htmlspecialchars(substr($product['products_name'],0,32)).round($product['qty']).$item_price;
}
if ($order['shipping_method_costs'] >0)
{
	$hash_array[] ='999999'.'shipping costs1'.($order['shipping_method_costs']*100);
}
if ($order['payment_method_costs'] >0)
{
	$hash_array[] ='999998'.'payment costs1'.($order['payment_method_costs']*100);
}
// for debugging purposes
/*
	echo implode("",$hash_array)."\n";
	echo '<pre>';
	print_r($hash_array);
	echo '</pre>';
*/
$shastring			= implode("",$hash_array);
$clean_shaString	= html_entity_decode($shastring); 
$not_allowed 		= array("\t", "\n", "\r", " "); 
$clean_shaString 	= str_replace($not_allowed, "",$clean_shaString); 
$shasign 			= sha1($clean_shaString);	
$content .= '<form method="post" action="'.$ms['url'].'" id="pspform" name="pspform" target="pspform">
<input type="hidden" name="merchantID" value="'.$merchant_id.'">
<input type="hidden" name="subID" value="'.$merchant_subid.'">
<input type="hidden" name="amount" value="'.$amount.'">
<input type="hidden" name="purchaseID" value="'.$order['orders_id'].'">
<input type="hidden" name="language" value="nl">
<input type="hidden" name="currency" value="EUR">
<input type="hidden" name="description" value="'.substr('Payment to '.htmlspecialchars($ms['MODULES']['ST0RE_NAME']), 0, 32).'">
<input type="hidden" name="paymentType" value="ideal">
<input type="hidden" name="validUntil" value="'.$validUntil.'">'."\n";
$content .= '<input type="hidden" name="hash" value="'. $shasign .'">'."\n";
$i=0;
foreach ($order['products'] as $product)
{	
	$i++;
	$item_price=(round(preg_replace("/^0/",'',$product['final_price']+($product['final_price']/100*$product['products_tax'])),2)*100);	
	$content .='
	<input type="hidden" name="itemNumber'.$i.'" value="'.$product['products_id'].'">
	<input type="hidden" name="itemDescription'.$i.'" value="'.htmlspecialchars(substr($product['products_name'],0,32)).'">
	<input type="hidden" name="itemQuantity'.$i.'" value="'.round($product['qty']).'">
	<input type="hidden" name="itemPrice'.$i.'" value="'.$item_price.'">
	';
}
if ($order['shipping_method_costs'] >0)
{
	$i++;
	$content .='
	<input type="hidden" name="itemNumber'.$i.'" value="999999">
	<input type="hidden" name="itemDescription'.$i.'" value="shipping costs">
	<input type="hidden" name="itemQuantity'.$i.'" value="1">
	<input type="hidden" name="itemPrice'.$i.'" value="'.($order['shipping_method_costs']*100).'">
	';
}
if ($order['payment_method_costs'] >0)
{
	$i++;
	$content .='
	<input type="hidden" name="itemNumber'.$i.'" value="999999">
	<input type="hidden" name="itemDescription'.$i.'" value="payment costs">
	<input type="hidden" name="itemQuantity'.$i.'" value="1">
	<input type="hidden" name="itemPrice'.$i.'" value="'.($order['payment_method_costs']*100).'">
	';
}
$content .= '
<input type="hidden" name="urlCancel" value="http://'.$server['HTTP_HOST'].'/'.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_cancelurl').'">
<input type="hidden" name="urlSuccess" value="http://'.$server['HTTP_HOST'].'/'.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl').'">
<input type="hidden" name="urlError" value="http://'.$server['HTTP_HOST'].'/'.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_exceptionurl').'">
<input type="submit" name="submit2" value="Veilig betaling via iDEAL" id="submit2">
</form>
';
if ($vars['autosubmit']=='true')
{
	$content.= '<script type="text/javascript" language="JavaScript">
					jQuery(document).ready(function(){
					jQuery("#pspform").attr(\'target\',\'\');
					jQuery("#pspform").submit();
					});
				</script>
';
}

?>